-- dfs_search.e
--
-- Ben Lin 5/98
-- doit largely copied from Jeff Kingston's note to me
-- Perform a depth-first search on a blackboard

class DFS_SEARCH inherit SEARCH_STRATEGY
	-- Depth-first search

feature

	display_list(list : COLLECTION[COMMAND]) is
		-- Show list of commands
	local
		i : integer
	do
		io.put_string("Suggestions:%N")
		from i := list.lower
		until i > list.upper
		loop
			list.item(i).display
			i := i + 1
		end
	end

	doit(bb : BLACKBOARD) is
		-- do a search on the blackboard bb
	local
		i : INTEGER
		command_list : COMMAND_LIST
	do
		command_list := bb.get_open
		from i := command_list.lower
		until bb.finished or i > command_list.upper
		loop
			command_list.item(i).execute
			doit(bb)
			if not bb.finished
			then
				command_list.item(i).unexecute
				i := i + 1
			end
		end

	end

	display is
		-- Display name of search
	do
		io.put_string("Depth First Search%N")
	end
end

