-- Ben Lin 5/98
class PROPAGATE_TICK inherit OBSERVER
	-- Propagates ticks
	-- For example: If X is Y, and a tick is placed meaning X is Z,
	-- then this will generate a tick meaning Y is Z, or a die
	-- command if this is not possible.

creation make
feature
	make is
	do
	end

	update(last : ADD_TICK) is
	local
		ticki, tickj : INTEGER
		tickrow, tickcol : INTEGER
		j : INTEGER
		y : INTEGER
		bb : LP_BOARD
	do
		bb := last.bb
		ticki := last.i
		tickj := last.j
		tickrow := last.x
		tickcol := last.y

		from
			j := 1
		until j > bb.sub_count
		loop
			if j /= ticki and j /= tickj then
				from
					y := 1
				until y > bb.size
				loop

					propagate(last, ticki, j, tickj, tickrow, y, tickcol)
					y := y + 1
				end
			end
			j := j + 1
		end
	end
	
	propagate(last : ADD_TICK; i, j, k, x, y, z : INTEGER) is
	require
		i /= j
		j /= k
	local
		bb : LP_BOARD
	do
		bb := last.bb

		inspect bb.board.item(i, j, x, y)
		when -1 then
			inspect bb.board.item(j, k, y, z)
			when 0 then
				last.forced_cross(j, k, y, z)
			when 1 then
				last.forced_die
			else
			end
		when 1 then
			inspect bb.board.item(j, k, y, z)
			when 0 then
				last.forced_tick(j, k, y, z)
			when -1 then
				last.forced_die
			else
			end
		when 0 then
			inspect bb.board.item(j, k, y, z)
			when 1 then
				last.forced_tick(i, j, x, y)
			when -1 then
				last.forced_cross(i, j, x, y)
			else
			end
		end
	end
end
