-- Ben Lin 28/5/98
class TICK_LINK inherit OBSERVER
	-- Makes sure destination is ticked if called
	--
	-- Typical usage: place this on a particular square's
	-- tick (or cross) observer list. Then whenever that particular
	-- square is ticked (or crossed), an `ADD_TICK' command will
	-- be generated on the square pointed to by
	-- `i', `j', `x', `y'.
	-- This is useful in certain types of clues.

creation make
feature
	make(i_dest, j_dest, x_dest, y_dest : INTEGER) is
	do
		i := i_dest
		j := j_dest
		x := x_dest
		y := y_dest
	end

	update(last : LP_COMMAND) is
	local
		count : INTEGER
		bb : LP_BOARD
	do
		bb := last.bb
		inspect bb.board.item(i, j, x, y)
		when -1 then
			last.forced_die
		when 0 then
			last.forced_tick(i, j, x, y)
		else
		end
	end

feature {NONE}
	i, j, x, y : INTEGER
end

